package as.adamsmith.etherealdialpad;

import android.content.Context;
import android.os.Bundle;
import android.os.RemoteException;
import android.view.*;
import android.graphics.*;

public class BasicPad extends Pad {	
	FlatView flatView;
	
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		
		flatView = new FlatView(this);
		setContentView(flatView);
	}
	
	class FlatView extends SurfaceView {
		float u, v;
		boolean active;
		
		public FlatView(Context context) {
			super(context);
			setBackgroundColor(0xFF404040);
		}
		
		@Override
		public boolean onTouchEvent(MotionEvent event) {
			u = event.getX() / getWidth();
			v = 1.0f - event.getY() / getHeight();
			
			if(event.getAction() == MotionEvent.ACTION_DOWN) {
				active = true;
				
				try {
					synthService.primaryOn();
					synthService.primaryXY(u, v);
				} catch (RemoteException e) {
					e.printStackTrace();
				}
			}
			
			if(event.getAction() == MotionEvent.ACTION_UP) {
				active = false;

				try {
					synthService.primaryOff();
					synthService.primaryXY(u, v);
				} catch (RemoteException e) {
					e.printStackTrace();
				}
			}
			
			if(event.getAction() == MotionEvent.ACTION_MOVE) {
				
				try {
					synthService.primaryXY(u, v);
				} catch (RemoteException e) {
					e.printStackTrace();
				}
			}
			
			invalidate();
			
			return true;
		}
		
		@Override
		public void onDraw(Canvas canvas) {
			
			if(active) {
				int r = (int)( 128+128*(u-0.5) );
				int g = (int)( 128+128*(v-0.5) );
				int b = (int)( 128+128*(0.5-u) );
				canvas.drawARGB(255, r, g, b);
			}
		}
	}
}
