package as.adamsmith.etherealdialpad;

import android.app.Activity;
import android.content.ComponentName;
import android.content.Context;
import android.content.Intent;
import android.content.ServiceConnection;
import android.os.Bundle;
import android.os.IBinder;
import android.view.Window;

import as.adamsmith.etherealdialpad.dsp.*;

public abstract class Pad extends Activity {
	ISynthService synthService = null;
	SynthServiceConnection synthServiceConnection = new SynthServiceConnection();
	
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		
		getWindow().requestFeature(Window.FEATURE_NO_TITLE);
	}
	
	
	@Override
	public void onResume() {
		super.onResume();
		
		bindService(
				new Intent(ISynthService.class.getName()),
				synthServiceConnection,
				Context.BIND_AUTO_CREATE);
	}
	
	@Override
	public void onPause() {
		super.onPause();
		
		unbindService(synthServiceConnection);
	}
	
	class SynthServiceConnection implements ServiceConnection {

		@Override
		public void onServiceConnected(ComponentName className, IBinder service) {
			synthService = ISynthService.Stub.asInterface(service);
			}

		@Override
		public void onServiceDisconnected(ComponentName className) {
			synthService = null;
		}
	}
	
	// Pad ideas:
	// kp2, single touch, color fade
	// classic light trails with spline
	// aurora
	// accel to rotate around orb, touching for press
}
